"Save system vars that will be altered"
Smalltalk at: #SSWTempDefaultPackage put: Package manager defaultPackage!
Package manager defaultPackage: (Package manager packageNamed: 'SSW EditableListView' ifNone: [SSWTempDefaultPackage])!

!EditableListView methodsFor!
nmCustomDraw: pNMHDR

	"Override to trap or queue a (sub)item post-paint notification"

	| context columnIndex drawStage res |

	context := self customDrawContextClass fromAddress: pNMHDR.
	columnIndex := context iSubItem + 1.

	"Only needed to manually draw icons when multiline or the editor is active"
	(self isMultiline or: [(columnIndex >= 1) and: [columnIndex <= columns size and: [(self columnAtIndex: columnIndex) editor ifNil: [false] ifNotNil: [ :ed | ed hasVisibleStyle]]]]) ifFalse: [^super nmCustomDraw: pNMHDR].

	"Postdraw notification (see below)?"
	((drawStage := pNMHDR dwordAtOffset: 12) allMask: 65538 "CDDS_ITEMPOSTPAINT") ifTrue:
		[columnIndex > columns size ifTrue: [^CDRF_DODEFAULT].
		context rc width = 0 ifTrue: [^CDRF_DODEFAULT].
		context
			item: (self objectFromHandle: context itemHandle ifAbsent: [^CDRF_DODEFAULT]);
			view: self.	"The control attempts to draw stuff that isn't there on occassion"
		self postDraw: context columnIndex: columnIndex.
		^CDRF_DODEFAULT].

	res := super nmCustomDraw: pNMHDR.

	"Request postdraw notification - see above"
	^((drawStage allMask: CDDS_ITEMPREPAINT) and: [(res = CDRF_DODEFAULT)
		and: [(self hasColumnImages and: [drawStage allMask: CDDS_SUBITEM])
				or: [self hasColumnImages not and: [self hasImageBlock and: [columnIndex = 1]]]]])
					ifTrue: [res | 16r10 "CDRF_NOTIFYPOSTPAINT"]
					ifFalse: [res]! !
!EditableListView categoriesFor: #nmCustomDraw:!event handling!public! !

!EditableListView methodsFor!
onViewOpened

	super onViewOpened.

	self isMultiSelect 
		ifTrue: [self setWindowStyle: (self getWindowStyle maskClear: LVS_SINGLESEL)]
		ifFalse: [self setWindowStyle: (self getWindowStyle maskSet: LVS_SINGLESEL)].

	self allColumns do: 
		[ :each | 
		each 
			createEditorIn: self;
			customDrawBlock: (MessageSend receiver: self selector: #drawSubItem: arguments: (Array with: nil))]! !
!EditableListView categoriesFor: #onViewOpened!event handling!public! !

!EditableListView methodsFor!
rowPixelHeight

	^(self rowHeight ifNil: [1]) = 1
		ifTrue: [super rowPixelHeight]
		ifFalse: [((self actualFont pixelSize + 2) * self rowHeight) truncated + 1]! !
!EditableListView categoriesFor: #rowPixelHeight!accessing!private! !

(Package manager packageNamed: 'SSW EditableListView' ifNone: [DeafObject current]) isChanged: false!

"Revert altered system vars"
Package manager defaultPackage: (Smalltalk at: #SSWTempDefaultPackage)!
Smalltalk removeKey: #SSWTempDefaultPackage!